/*
* DVD-Audio Decoder plugin
* Copyright (c) 2009 Maxim V.Anisiutkin <maxim.anisiutkin@gmail.com>
*
* DVD-Audio Decoder is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* DVD-Audio Decoder is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with FFmpeg; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#ifndef _DVDA_METABASE
#define _DVDA_METABASE

#include "dvda_filesystem.h"
#include "foo_version.h"

#import <msxml3.dll>

#pragma warning(disable:4996)

#define TAG_ROOT       "root"
#define TAG_STORE      "store"
#define TAG_TRACK      "track"
#define TAG_INFO       "info"
#define TAG_META       "meta"
#define TAG_REPLAYGAIN "replaygain"

#define ATT_ID      "id"
#define ATT_NAME    "name"
#define ATT_TYPE    "type"
#define ATT_VALUE   "value"
#define ATT_VALSEP  ";"
#define ATT_VERSION "version"


#define METABASE_CATALOG "dvda_metabase"
#define METABASE_VERSION "1.1"

class dvda_metabase_t {
	string_formatter(store_id);
	string_formatter(store_root);
	string_formatter(store_path);
	string_formatter(store_file);
	MSXML2::IXMLDOMDocumentPtr xmldoc;
	bool xmldoc_changed;
	VARIANT xmlfile;
	bool metabase_initialized;
public:
	dvda_metabase_t(dvda_filesystem_t* dvda_filesystem, const char* type);
	~dvda_metabase_t();
	bool get_meta_info(t_uint32 subsong, file_info& info);
	bool set_meta_info(t_uint32 subsong, const file_info& info);
	bool commit();
private:
	void subsong_to_string(t_uint32 subsong, string_formatter& subsong_name);
	bool init_xmldoc(const char* store_type);
	MSXML2::IXMLDOMNodePtr get_track_node(t_uint32 subsong);
	MSXML2::IXMLDOMNodePtr new_track_node(t_uint32 subsong);
	bool dvda_metabase_t::set_info_tag(MSXML2::IXMLDOMNodePtr& node_track, const char* tag_type, string_formatter& tag_name, string_formatter& tag_value);
	void utf2xml(string_formatter& src, string_formatter& dst);
	void xml2utf(string_formatter& src, string_formatter& dst);
};

#endif
