#include "dvd_input.h"

dvd_input_t dvdinput_open(const char* path) {
  dvd_input_t dev = new dvda_file_t;
	if (!dev)
		return NULL;
	dev->open(path);
	if (!dev->is_open()) {
		delete dev;
		return NULL;
	}
  return dev;
}

int dvdinput_close(dvd_input_t dev) {
	if (dev)
		delete dev;
	return 0;
}

int dvdinput_seek(dvd_input_t dev, int block) {
	if (!dev->seek(2048 * block))
		return 0;
	return block;
}

int dvdinput_read(dvd_input_t dev, void *buffer, int blocks, int flags) {
	return dev->read(buffer, 2048 * blocks) / 2048;
}

extern "C" int strcasecmp(char* a, char* b) {
	return _stricmp(a, b);
}
